#include "Xbp.ch"
#include "Appevent.ch"
#include "dll.ch"

PROCEDURE  Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg1, oDlg2, oDraw1, oDraw2, oBtn, bSetFocus, bKillFocus

   SetColor("N/W")
   CLS

   bSetFocus  := {|mp1,mp2,obj| ;
                   QOut( obj:title, "hat den Fokus bekommen") }

   bKillFocus :=  {|mp1,mp2,obj| ;
                   QOut( obj:title, "hat den Fokus verloren") }

   oDlg1         := XbpDialog():new(AppDesktop() , , {0,0}, {800,600}, , .T.)
   oDlg1:title   := "Check Mouse outside Dialog"
   oDlg1:titlebar := .T.
   oDlg1:taskList := .T.
   oDlg1:create()
   oDlg1:setDisplayFocus  := bSetFocus
   oDlg1:killDisplayFocus := bKillFocus
   oDlg1:DrawingArea:motion := {| aPos, uNIL, oSelf | IsInDialog(aPos,oSelf) }

   CenterControl(oDlg1)

   oDlg1:Show()

   // Event loop
   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

FUNCTION IsInDialog(aIsInDialog,oSelf)
LOCAL aPos  := oSelf:setParent():CurrentPos()
LOCAL aSize := oSelf:setParent():CurrentSize()
LOCAL aCur  := GetCursorPos()
LOCAL lRet  := .T.

   SetColor("N/W")

   IF aCur[1] < aPos[1]          .OR. ;
      aCur[1] > aPos[1]+aSize[1] .OR. ;
      aCur[2] < aPos[2]          .OR. ;
      aCur[2] > aPos[2]+aSize[2]
      lRet  := .F.
      SetColor("R+/W")
   ENDIF

   QOut( VAR2CHAR(aCur))

RETURN lRet

FUNCTION GetCursorPos()
LOCAL cBuffer    := SPACE( 8 )
LOCAL aPos := { nil, nil }
LOCAL aSize := AppDeskTop():CurrentSize()

   DllCall( "User32.DLL", DLL_STDCALL, "GetCursorPos", @cBuffer )

   aPos[ 1 ] := Bin2U( SUBSTR( cBuffer, 1, 4 ) )
   aPos[ 2 ] := Bin2U( SUBSTR( cBuffer, 5, 4 ) )

   ***** For Xbase++ Coordinates, Bottom Left == 0,0  use.....
   aPos[ 2 ] := aSize[ 2 ] - aPos[ 2 ]

RETURN aPos
































